 var ws = null;
 var pc;
 var audio_video_stream;
 var recorder = null;
 var aa_streams = [];
 var mediaConstraints = {
     optional: [],
     mandatory: {
         OfferToReceiveAudio: true,
         OfferToReceiveVideo: true
     }
 };
 var iceCandidates = [];
 var botton_buff = ["pause", "mute", 'stop', 'photo', "record", "play", 'dn_photo', 'dn_video'];
 var flg_view = 0;
 var flg_record = 0;
 var remoteVideo = document.getElementById("remote-video");

 var led = 0;
 var rec_flg = 1;

 ws00 = new WebSocket('ws://raspberrypi.local:8070');

 ws00.onmessage = function (evt) {
     var msg = evt.data;
     console.log(msg);
     switch(msg)
     {
         case 'start':// Start Stream without webrtc
                        rec_flg = 0;
                        start();
                        break;

         case 'start_record':  // Start Stop recording
                        start_stop_record();
                        break;

         case 'stop_record':  // Start Stop recording
                       start_stop_record();
                       rec_flg = 1;
                       break;

         case 'download': // Download
                        download();
                        break;

         case 'puase': // back or pause
                        puase();
                        break;

         case 'stop':   // stop
                        stop();
                        break;
     }
 };

function bt_led() {
     led = led ^ 1;
     if(led)
     {
         document.getElementById("bt_LED").textContent = 'LED_ON'
         document.getElementById("bt_LED").style.backgroundColor = 'red';
     }
     else
     {
         document.getElementById("bt_LED").textContent = 'LED_OFF'
         document.getElementById("bt_LED").style.backgroundColor = "#228b22";
     }
     ws00.send('LED,' + String(led));
}

function bt_rec() {
     ws00.send('REC');
}

botton_buff.forEach(element => set_Btn(element, 0));

function createPeerConnection() {
     try {
         pc = new RTCPeerConnection();
         pc.onicecandidate = onIceCandidate;
         pc.ontrack = onTrack;
         pc.onremovestream = onRemoteStreamRemoved;
         console.log("peer connection successfully created!");
    } catch (e) {
         console.error("createPeerConnection() failed");
     }
 }

 function onIceCandidate(event) {
     if (event.candidate && event.candidate.candidate) {
         var candidate = {
             sdpMLineIndex: event.candidate.sdpMLineIndex,
             sdpMid: event.candidate.sdpMid,
             candidate: event.candidate.candidate
         };
         var request = {
             what: "addIceCandidate",
             data: JSON.stringify(candidate)
         };
         ws.send(JSON.stringify(request));
     } else {
         console.log("End of candidates.");
     }
 }

 function addIceCandidates() {
     iceCandidates.forEach(function (candidate) {
         pc.addIceCandidate(candidate,
             function () {
                 console.log("IceCandidate added: " + JSON.stringify(candidate));
             },
             function (error) {
                 console.error("addIceCandidate error: " + error);
             }
         );
     });
     iceCandidates = [];
 }

 function onTrack(event) {
     console.log("Remote track!");
     var remoteVideoElement = document.getElementById('remote-video');
     remoteVideoElement.srcObject = event.streams[0];
     aa_streams[0] = event.streams[0];
     botton_buff = ["pause", "mute", 'stop', 'photo', "record"];
     botton_buff.forEach(element => set_Btn(element, 1));
 }

 function onRemoteStreamRemoved(event) {
     var remoteVideoElement = document.getElementById('remote-video');
     remoteVideoElement.srcObject = null;
     remoteVideoElement.src = ''; // TODO: remove
 }

function start() {
     set_Btn('start', 0)
     if ("WebSocket" in window) {
         document.getElementById("stop").disabled = false;
         document.getElementById("start").disabled = true;
         document.documentElement.style.cursor = 'wait';

         var protocol = location.protocol === "https:" ? "wss:" : "ws:";
         ws = new WebSocket(protocol + '//raspberrypi.local:8090/stream/webrtc');
         ws.onopen = async function () {
             iceCandidates = [];
             remoteDesc = false;
             if(rec_flg) audio_video_stream = await navigator.mediaDevices.getUserMedia({video: false, audio: true});
             createPeerConnection();
             if(rec_flg) audio_video_stream.getTracks().forEach(track => pc.addTrack(track, audio_video_stream));
             var request = {
                 what: "call",
                 options: {
                     force_hw_vcodec: false,
                     vformat: "30",
                     trickle_ice: true
                 }
             };
             ws.send(JSON.stringify(request));
             console.log("call(), request=" + JSON.stringify(request));
         };

         ws.onmessage = function (evt) {
             var msg = JSON.parse(evt.data);
             if (msg.what !== 'undefined') {
                 var what = msg.what;
                 var data = msg.data;
             }
             console.log("message =" + what);

             switch (what) {
                 case "offer":
                     pc.setRemoteDescription(new RTCSessionDescription(JSON.parse(data)),
                             function onRemoteSdpSuccess() {
                                 remoteDesc = true;
                                 addIceCandidates();
                                 console.log('onRemoteSdpSucces()');
                                 pc.createAnswer(function (sessionDescription) {
                                     pc.setLocalDescription(sessionDescription);
                                     var request = {
                                         what: "answer",
                                         data: JSON.stringify(sessionDescription)
                                     };
                                     ws.send(JSON.stringify(request));
                                     console.log(request);

                                 }, function (error) {
                                     alert("Failed to createAnswer: " + error);

                                 }, mediaConstraints);
                             },
                             function onRemoteSdpError(event) {
                                 alert('Failed to set remote description (unsupported codec on this browser?): ' + event);
                                 stop();
                             }
                     );
                     break;

                 case "iceCandidate": // when trickle is enabled
                     if (!msg.data) {
                         console.log("Ice Gathering Complete");
                         break;
                     }
                     var elt = JSON.parse(msg.data);
                     let candidate = new RTCIceCandidate({sdpMLineIndex: elt.sdpMLineIndex, candidate: elt.candidate});
                     iceCandidates.push(candidate);
                     if (remoteDesc)
                         addIceCandidates();
                     document.documentElement.style.cursor = 'default';
                     break;
             }
         };

         ws.onclose = function (evt) {
             if (pc) {
                 pc.close();
                 pc = null;
             }
             document.getElementById("stop").disabled = true;
             document.getElementById("start").disabled = false;
             document.documentElement.style.cursor = 'default';
         };

         ws.onerror = function (evt) {
             alert("An error has occurred!");
             ws.close();
         };

     } else {
         alert("Sorry, this browser does not support WebSockets.");
     }
 }

 function stop() {
     botton_buff = ["pause", "mute", 'stop', 'photo', "record", "play", 'dn_photo', 'dn_video'];
     botton_buff.forEach(element => set_Btn(element, 0));
     set_Btn('start', 1);

     if (audio_video_stream) {
         try {
             if (audio_video_stream.getVideoTracks().length)
                 audio_video_stream.getVideoTracks()[0].stop();
             if (audio_video_stream.getAudioTracks().length)
                 audio_video_stream.getAudioTracks()[0].stop();
             audio_video_stream.stop(); // deprecated
         } catch (e) {
             for (var i = 0; i < audio_video_stream.getTracks().length; i++)
                 audio_video_stream.getTracks()[i].stop();
         }
         audio_video_stream = null;
     }
     document.getElementById('remote-video').srcObject = null;
     document.getElementById('remote-video').src = ''; // TODO; remove
     if (pc) {
         pc.close();
         pc = null;
     }
     if (ws) {
         ws.close();
         ws = null;
     }
     document.getElementById("stop").disabled = true;
     document.getElementById("start").disabled = false;
     document.documentElement.style.cursor = 'default';
 }

 function pause() {
     botton_buff = ["play", 'dn_photo', 'dn_video'];
     botton_buff.forEach(element => set_Btn(element, 0));
     botton_buff = ["mute", 'stop', 'photo', "record"];
     botton_buff.forEach(element => set_Btn(element, remoteVideo.paused));
     if (remoteVideo.paused){
         if(flg_view == 1){
             remoteVideo.style.display = "";
             remoteVideo.muted = "false";
             document.getElementById('play-video').style.display = "none";
             flg_view = 0;
             remoteVideo.muted = "false";
         }
         document.getElementById("pause").innerHTML = 'Pause';
         remoteVideo.play();
     }
     else{
         remoteVideo.pause();
         document.getElementById('pause').innerHTML = 'Back';
     }

     set_Btn("pause",1);
 }

 function mute() {
     remoteVideo.muted = !remoteVideo.muted;
     if (remoteVideo.muted){
         document.getElementById("mute").innerHTML = 'No mute';
     }
     else{
         document.getElementById('mute').innerHTML = 'Mute';
     }
 }

 function download() {
     if (recordedBlobs !== undefined) {
         var blob = new Blob(recordedBlobs, {type: 'video/webm'});
//         var url = window.URL.createObjectURL(blob);
         var url = URL.createObjectURL(blob);
         var a = document.createElement('a');
         a.style.display = 'none';
         a.href = url;
         a.download = 'video.webm';
         document.body.appendChild(a);
         a.click();
         setTimeout(function () {
             document.body.removeChild(a);
//             window.URL.revokeObjectURL(url);
             URL.revokeObjectURL(url);
         }, 100);
     }
 }

 function start_stop_record() {
     botton_buff = ["start", "pause", "mute", 'stop', 'photo', "play", 'dn_video', 'dn_photo'];
     botton_buff.forEach(element => set_Btn(element, 0));
     set_Btn("record",1);
     document.getElementById('pause').innerHTML = 'Back';
     if (pc && !flg_record) {
         if (aa_streams.length) {
             console.log("Starting recording");
             startRecording(aa_streams[0]);
             document.getElementById('record').innerHTML = 'Stop';
             flg_record = 1;
         }
     }
     else {
             console.log("Stop recording");
             botton_buff = ["pause", "record", "play", 'dn_video'];
             botton_buff.forEach(element => set_Btn(element, 1));
             stop_record();
             document.getElementById('record').innerHTML = 'Video';
             remoteVideo.pause();
             set_Btn("record",0);
             flg_record = 0;
     }
 }

 function startRecording(stream) {
     recordedBlobs = [];
     var options = {mimeType: 'video/webm;codecs=vp9,opus'};
     if (!MediaRecorder.isTypeSupported(options.mimeType)) {
         console.log(options.mimeType + ' is not Supported');
         //options = {mimeType: 'video/webm;codecs=vp8'};
         options = {mimeType: 'video/webm;codecs=vp8,opus'};
         if (!MediaRecorder.isTypeSupported(options.mimeType)) {
             console.log(options.mimeType + ' is not Supported');
             options = {mimeType: 'video/webm;codecs=h264'};
             if (!MediaRecorder.isTypeSupported(options.mimeType)) {
                 console.log(options.mimeType + ' is not Supported');
                 options = {mimeType: 'video/webm'};
                 if (!MediaRecorder.isTypeSupported(options.mimeType)) {
                     console.log(options.mimeType + ' is not Supported');
                     options = {mimeType: ''};
                 }
             }
         }
     }
     try {
         recorder = new MediaRecorder(stream, options);
     } catch (e) {
         console.error('Exception while creating MediaRecorder: ' + e);
         alert('Exception while creating MediaRecorder: ' + e + '. mimeType: ' + options.mimeType);
         return;
     }
     console.log('Created MediaRecorder', recorder, 'with options', options);
     recorder.ondataavailable = handleDataAvailable;
     recorder.onwarning = function (e) {
         console.log('Warning: ' + e);
     };
     recorder.start();
     console.log('MediaRecorder started', recorder);
 }

 function stop_record() {
     if (recorder) {
         recorder.stop();
         console.log("recording stopped");
         document.getElementById('record').innerHTML = 'Video';
         recorder = null;
     }
 }

 function handleDataAvailable(event) {
     //console.log(event);
     if (event.data && event.data.size > 0) {
         recordedBlobs.push(event.data);
     }
 }

 function play_video() {
     botton_buff = ["start", "mute", 'stop', 'photo', "record", 'dn_photo'];
     botton_buff.forEach(element => set_Btn(element, 0));
     botton_buff = ["pause", "play", 'dn_video'];
     botton_buff.forEach(element => set_Btn(element, 1));
     document.getElementById('pause').innerHTML = 'Back';
     console.log('Play video');
     recorder = null;
     flg_view = 1;
     remoteVideo.style.display = "none";
     remoteVideo.pause();
     remoteVideo.muted = "true";
     document.getElementById('play-video').style.display = "";

     var superBuffer = new Blob(recordedBlobs, {type: 'video/webm'});
     var recordedVideoElement = document.getElementById('play-video');
     recordedVideoElement.src = URL.createObjectURL(superBuffer);
 }

 function dn_photo(){
     var canvas = document.querySelector('canvas');
     var url = canvas.toDataURL('image/jpeg', 1.0);
     var a = document.createElement('a');
     a.style.display = 'none';
     a.href = url;
     a.download = 'pic.jpg';
     document.body.appendChild(a);
     a.click();
     setTimeout(function () {
     document.body.removeChild(a);
         window.URL.revokeObjectURL(url);
     }, 100);
 }

 function take_photo() {
     botton_buff = ['start', "mute", 'stop', "record", "play", 'dn_video'];
     botton_buff.forEach(element => set_Btn(element, 0));
     botton_buff = ['pause', "photo", 'dn_photo'];
     botton_buff.forEach(element => set_Btn(element, 1));
     document.getElementById('pause').innerHTML = 'Back';
     remoteVideo.pause();
     var canvas = document.querySelector('canvas');
     canvas.width = remoteVideo.videoWidth;
     canvas.height = remoteVideo.videoHeight;
     canvas.getContext('2d').drawImage(remoteVideo, 0, 0, canvas.width, canvas.height);

 }

 function set_Btn(_id, flg) {
     var flg_able = true;
     var flg_back = "gray";
     if(flg){
         flg_able = false;
         flg_back = "#228b22";
     }
     document.getElementById(_id).disabled = flg_able;
     document.getElementById(_id).style.backgroundColor = flg_back;
 }
