#!/usr/bin/env python3
from websocket_server import WebsocketServer
import RPi.GPIO as GPIO
import time

GPIO.setmode(GPIO.BCM)
GPIO.setup(23, GPIO.OUT)
GPIO.output(23, 0)

# new client
def new_client(client, server):
    print('New client {} has joined.'.format(client['address'][0]))

# client close
def client_left(client, server):
    print('Client {} has left.'.format(client['address'][0]))

# message from client
def message_received(client, server, message):
    print('command: ', message)
    cmd = message.split(',')
    if(cmd[0] == 'LED'):
        GPIO.output(23, int(cmd[1]))

    elif(cmd[0] == 'REC'):
        server.send_message(client, 'start')
        time.sleep(5)
        server.send_message(client, 'start_record')
        time.sleep(10)
        server.send_message(client, 'stop_record')
        time.sleep(1)
        server.send_message(client, 'download')
        time.sleep(1)
        server.send_message(client, 'pause')
        time.sleep(1)
        server.send_message(client, 'stop')

# set server port @8070
server = WebsocketServer(port=8070, host='raspberrypi.local')
# define event handler
server.set_fn_new_client(new_client)
server.set_fn_client_left(client_left)
server.set_fn_message_received(message_received)
# start
print('Start Server')
server.run_forever()
